close all; clear all; clc
%% Run the ODE with the optimal parameters
% constant parameter values
Xpre=10; kprodEprod=.5; kdegEdeg=.5; kdisEdis=1; 
% minimized parameter values
xOPT=example_optimization_dimerFormation;
kdimEdim=xOPT(1); Y_tot=xOPT(2);
% experimental data
t_exp=  [0 1 3 ]; XY_exp=[.5 2.5 3 ]./.5; 
% Initial conditions 
X_0=0; Y_0=Y_tot-XY_exp(1);
y0=[X_0 Y_0]; 
% integration interval 
tspan = [0 t_exp(end)+.5];
% Call the ODE solver 
[t,y] = ode45(@(t,y)dimerFormation(t,y ,Xpre, kprodEprod, kdegEdeg, kdimEdim, kdisEdis, Y_tot),tspan,y0);

%% calculate the final cost
XY_pred = interp1(t,(Y_tot-y(:,2)),t_exp);
Cost=(sum((XY_pred-XY_exp).^2));

%%Plot the results
figure;
scatter(t_exp, XY_exp, 'k'); hold on
plot(t, Y_tot-y(:,2), 'k'); axis square
ylabel('XY dynamics [fold increase]')
xlabel('time [hours]')
title(['minimal cost:' num2str(Cost) ' kdim=' num2str(xOPT(1))  ' Ytot=' num2str(xOPT(2))]);
