close all
clear all
clc

%%% stochastic simulations: time-driven algorithm

% simple raction: A is degraded. one reaction, but now
%instead of sayng it is deterministic we assume stochastic event with
%intrinsic noise. This is, the probability of A0 of being degraded is k1.


% initial conditions:
A0=10; % discrete number of molecules, not concentrations.
y0=A0;
%time of final integration
tend=1000;

%% el determinista
linear_degradation=@(t,y, a)-y*a;

a=.3; % production rate 

max_iterations=1000;

for iteration=1:1:max_iterations;

    At=A0; % current concentration
    current_time=0;

  %t=0;
  %stop_simulation=0;
for t=1:1:A0+1; %while At>0 % %number of iterations : note, here the number of iterations is the number of molecules! 
 %t=t+1;
 %Generate a random number
 r1=rand;
 
 % calculate the time at which the next reaction will occur%
 if At>0;
 alphat=At*a; % probability of a reaction to occur
 
 else
     
     alphat=a;
 end;
 deltat=log(1/r1).*(1/alphat);

 if At>0;
     
     Atplus1=At-1; % hay una degradacin
 elseif At==0
   Atplus1=At; % no pasa nada
   
  % stop_simulation=1;
 end;
 
 
 % update the value
 time_vector(t)=current_time+deltat;
 current_time= time_vector(t);
 At_vector(t)=At;
 
 At=Atplus1;
 
 
end; % number of steps

 time_vector_regular = 0:0.1:30; 
At_matrix(iteration,:) = interp1( time_vector,At_vector, time_vector_regular); 
 


plot(time_vector_regular, At_matrix(iteration,:))
hold on

end;


% the deterministic version



linear_degradation_solution=@(t,a,y0)y0*exp(-t.*a);



%[tdet,ydet] = ode45(@(t,y)linear_degradation(t,y,a),tspan,y0,a);

plot(time_vector_regular,linear_degradation_solution( time_vector_regular,a,y0),'color','b', 'LineWidth',2)
xlabel('time');
ylabel('y(t)');

%%
plot(time_vector_regular,nanmean(At_matrix),'color','r', 'LineWidth',2)


