function xOPT=example_optimization_dimerFormation
%% Experimental data
t_exp=  [0 1 3 ]; % hours post-stimulation
XY_exp=[.5 2.5 3 ]./.5; %Smad1- promoter complex
%% Optimization
% Give an initial guess for the parameter
xinit= [2 7]; 
% Run the optimization!
[x,J,flag]=fminsearch(@(x)CostFunction(x,t_exp, XY_exp),xinit);
xOPT=x;
end
function Cost=CostFunction(x,t_exp, XY_exp)
kdimEdim=x(1);
Ytot=x(2);
%% Solve the ODE - with this parameter
%constant parameters (those not minimized)
Xpre=10; kprodEprod=.5; kdegEdeg=.5; kdisEdis=1; 
%initial conditions
X_0=0; Y_0=Ytot-XY_exp(1);
y0=[X_0 Y_0]; %initial condition [X, Y]
%integration interval
tspan = [0 t_exp(end)]; %integration interval
% Call the ODE solver 
[t,y] = ode45(@(t,y)dimerFormation(t,y ,Xpre, kprodEprod, kdegEdeg, kdimEdim, kdisEdis, Ytot),tspan,y0);
% Focus on the variable to be compared with data
XY_t=Ytot-y(:,2);
% interpolate those values corresponding to the measurements
XY_predicted = interp1(t,XY_t,t_exp);
%% Calculate the cost of the predition vs. the experimental data
Cost=(sum((XY_predicted-XY_exp).^2));
end