close all
clear all
clc

%%% stochastic simulations: time-driven algorithm

% simple raction: A is degraded. one reaction, but now
%instead of sayng it is deterministic we assume stochastic event with
%intrinsic noise. This is, the probability of A0 of being degraded is k1.

% naive time-driven algorithm:


% initial conditions:
A0=10; % discrete number of molecules, not concentrations.

%time of final integration
tend=1000;

%% el determinista
linear_degradation=@(t,y, a)-y*a;

a=.3; % degradation rate 
y0=10;

% we run the stochastic version:
deltat=0.001; %time interval

max_iterations=300;

for iteration=1:1:max_iterations;

    At=A0; % current concentration
    current_time=0;

for t=1:1:tend; % discrete time steps
 
 %Generate a random number
 r1=rand;
 
 % probability of the degradation to occur in this inverval of time
 
 if r1< At*a*deltat;
     
     Atplus1=At-1; % hay una degradacin
 else
   Atplus1=At; % no pasa nada
 end;
 
 
 % update the value
 time_vector(t)=current_time+deltat;
 current_time= time_vector(t);
 At_vector(t)=At;
 
 At=Atplus1;
 
 % ah but we have to store
end;

At_matrix(iteration,:)= At_vector;


plot(time_vector, At_vector)
hold on

end;


% the deterministic version



linear_degradation_solution=@(t,a,y0)y0*exp(-t.*a);



%[tdet,ydet] = ode45(@(t,y)linear_degradation(t,y,a),tspan,y0,a);

plot(time_vector,linear_degradation_solution(time_vector,a,y0),'color','b', 'LineWidth',2)
xlabel('time');
ylabel('y(t)');


plot(time_vector,mean(At_matrix),'color','r', 'LineWidth',2)


%% time- driven vs. event-driven algorithm

error_matrix=sqrt((mean(At_matrix)-linear_degradation_solution(time_vector,a,y0)).^2);

mean(error_matrix)
% 0.0496, n=100


% 0.1426, n=10; 